Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Business Components
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.jbo.domain
Class DomainAttributeDef

    java.lang.Object
      |
      +--oracle.jbo.domain.DomainAttributeDef

public class DomainAttributeDef
extends java.lang.Object
implements AttributeDef

Fields inherited from interface oracle.jbo.AttributeDef
`ATTR_ASSOCIATED_ROW, ATTR_ASSOCIATED_ROWITERATOR, ATTR_DYNAMIC, ATTR_ENTITY_DERIVED, ATTR_PERSISTENT, ATTR_SQL_DERIVED, ATTR_TRANSIENT, READONLY, UPDATEABLE, UPDATEABLE_WHILE_NEW`

Constructor Summary
`DomainAttributeDef(java.lang.String name, java.lang.String columnName, int index, java.lang.Class javaType, int sqlType, java.lang.String sqlTypeName, int scale, int precision, boolean isMandatory)`
`DomainAttributeDef(java.lang.String name, java.lang.String columnName, int index, java.lang.Class javaType, int sqlType, java.lang.String sqlTypeName, int scale, int precision, boolean isMandatory, java.lang.String entityDefName)`

Method Summary
`byte` | `getAttributeKind()` Gets the attribute kind.
`java.lang.String` | `getColumnName()` Gets the name of the database column the attribute represents.
`java.lang.String` | `getColumnNameForQuery()` Gets the column name to be used in query statement.
`int` | `getIndex()` Gets the index of the attribute in the context of a `StoreInfo` instance.
`java.lang.Class` | `getJavaType()` Gets the Java class of the object stored for this attribute definition.
`java.lang.String` | `getName()` Gets the name of the attribute.
`int` | `getPrecision()` Gets the precision of a numeric or string attribute.
`java.util.Hashtable` | `getProperties()` Gets the table of properties.
`java.lang.Object` | `getProperty(java.lang.String hintName)` Retrieves the specified property, if it exists.
`java.lang.String` | `getReferencedObjectDefName()`
`int` | `getScale()` Get the scale value of a numeric attribute.
`int` | `getSQLType()` Gets the JDBC type of the attribute.
`byte` | `getUpdateableFlag()` Tests if an attribute can be modified.
`static org.w3c.dom.Node` | `getXMLContentNode(org.w3c.dom.Document xmlDoc, java.lang.Object attrValue, boolean isCData)`
`boolean` | `isMandatory()` Tests if an attribute does not allow null values.
`boolean` | `isPrimaryKey()` Tests if an attribute is a Primary Key.
`boolean` | `isQueriable()` Tests if an attribute is queriable.
`static java.lang.String` | `printAttrXMLDefinition(AttributeList row, java.lang.String attrTag, AttributeDef ad, java.util.Hashtable allDefs, java.io.PrintWriter pw, boolean bContainees)`
`java.lang.Object` | `refreshProperty(java.lang.String hintName)` Retrieves the specified property, if it exists.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DomainAttributeDef

    public DomainAttributeDef(java.lang.String name,
                              java.lang.String columnName,
                              int index,
                              java.lang.Class javaType,
                              int sqlType,
                              java.lang.String sqlTypeName,
                              int scale,
                              int precision,
                              boolean isMandatory)

### DomainAttributeDef

    public DomainAttributeDef(java.lang.String name,
                              java.lang.String columnName,
                              int index,
                              java.lang.Class javaType,
                              int sqlType,
                              java.lang.String sqlTypeName,
                              int scale,
                              int precision,
                              boolean isMandatory,
                              java.lang.String entityDefName)

Method Detail

### getAttributeKind

    public byte getAttributeKind()

  Gets the attribute kind.
  Specified by:
    getAttributeKind in interface AttributeDef
  Returns:
    one of the `ATTR` constants defined for this class.

### getName

    public java.lang.String getName()

  Gets the name of the attribute.
  Specified by:
    getName in interface AttributeDef
  Returns:
    the name of the attribute.

### getColumnName

    public java.lang.String getColumnName()

  Gets the name of the database column the attribute represents.
  Specified by:
    getColumnName in interface AttributeDef
  Returns:
    the name of the column.

### getColumnNameForQuery

    public java.lang.String getColumnNameForQuery()

  Description copied from interface: AttributeDef
  Gets the column name to be used in query statement. If the VO involves multiple entity usages, the column name may have to be qualified with the table alias for the appropriate entity. If the query statement is a full query ("expert mode"), the where-clause in the outer select must use column alias used for the inner select. This method takes care of all this and returns the right column name to be used for a query statement.
  Specified by:
    getColumnNameForQuery in interface AttributeDef
  Tags copied from interface: AttributeDef
  Returns:
    the column name to be used in query.

### getIndex

    public int getIndex()

  Gets the index of the attribute in the context of a `StoreInfo` instance.
  Specified by:
    getIndex in interface AttributeDef
  Returns:
    the index of the attribute row's definition object.

### getJavaType

    public java.lang.Class getJavaType()

  Gets the Java class of the object stored for this attribute definition.
  Specified by:
    getJavaType in interface AttributeDef
  Returns:
    the class of the attribute.

### getSQLType

    public int getSQLType()

  Gets the JDBC type of the attribute.
  Specified by:
    getSQLType in interface AttributeDef
  Returns:
    the JDBC type.
  See Also:
    `Types`

### getScale

    public int getScale()

  Get the scale value of a numeric attribute.
  Specified by:
    getScale in interface AttributeDef
  Returns:
    the scale value for this attribute, if applicable.

### getPrecision

    public int getPrecision()

  Gets the precision of a numeric or string attribute.

  'Precision' for a string is the maximum length.

  Specified by:
    getPrecision in interface AttributeDef
  Returns:
    the precision value for this attribute.

### isQueriable

    public boolean isQueriable()

  Tests if an attribute is queriable.

  Queriable attributes are those that may have a filter condition for the WHERE clause If this method returns false, the attribute will not be used in constructing the WHERE clause of SQL statements to fetch data.

  Specified by:
    isQueriable in interface AttributeDef
  Returns:
    `true` if this attribute is queriable.

### getUpdateableFlag

    public byte getUpdateableFlag()

  Tests if an attribute can be modified.
  Specified by:
    getUpdateableFlag in interface AttributeDef
  Returns:
    `READONLY`, `UPDATEABLE`, or `UPDATEABLE_WHILE_NEW`.

### isPrimaryKey

    public boolean isPrimaryKey()

  Tests if an attribute is a Primary Key.
  Specified by:
    isPrimaryKey in interface AttributeDef
  Returns:
    `true` if this is either a Primary Key attribute or part of the attributes that constitute the Primary Key for a given row.

### isMandatory

    public boolean isMandatory()

  Tests if an attribute does not allow null values.
  Specified by:
    isMandatory in interface AttributeDef
  Returns:
    `true` if this attribute cannot store a null value

### getProperty

    public java.lang.Object getProperty(java.lang.String hintName)

  Retrieves the specified property, if it exists.
  Returns:
    the named property.

### refreshProperty

    public java.lang.Object refreshProperty(java.lang.String hintName)

  Description copied from interface: Properties
  Retrieves the specified property, if it exists. If the application running in a 3 tier environment, it retrieves the property from the middle-tier server, refreshing the value on the client side. If the application is running in a 2 tier environment, it is equivalent to `getProperty`.
  Tags copied from interface: Properties
  Parameters:
    `hintName` - Property name.
  Returns:
    the value of the property, if any, otherwise `null`.

### getReferencedObjectDefName

    public java.lang.String getReferencedObjectDefName()

### getProperties

    public java.util.Hashtable getProperties()

  Gets the table of properties.
  Returns:
    a hashtable of properties.

### getXMLContentNode

    public static org.w3c.dom.Node getXMLContentNode(org.w3c.dom.Document xmlDoc,
                                                     java.lang.Object attrValue,
                                                     boolean isCData)

### printAttrXMLDefinition

    public static java.lang.String printAttrXMLDefinition(AttributeList row,
                                                          java.lang.String attrTag,
                                                          AttributeDef ad,
                                                          java.util.Hashtable allDefs,
                                                          java.io.PrintWriter pw,
                                                          boolean bContainees)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Business Components
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD